#include "widget.h"
#include "ui_widget.h"

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);

    m_synonymousMap.insert("daemon", "demon");
    m_synonymousMap.insert("daemon", "devil");
    m_synonymousMap.insert("daemon", "demonic");

    m_synonymousMap.insert("chief", "head");
    m_synonymousMap.insert("chief", "senior");
    m_synonymousMap.insert("chief", "superior");

    m_synonymousMap.insert("road", "roadway");
    m_synonymousMap.insert("road", "high road");
    m_synonymousMap.insert("road", "highway");

    for (auto key : m_synonymousMap.uniqueKeys())
    {
        m_keysModel.appendRow(new QStandardItem(key));
    }

    ui->wordsTableView->setModel(&m_keysModel);
    ui->synonymsTableView->setModel(&m_valuesModel);

    connect(ui->wordsTableView, &QTableView::clicked, this, &Widget::wordsTableViewClicked);
}

Widget::~Widget()
{
    delete ui;
}

void Widget::wordsTableViewClicked(const QModelIndex &index)
{
    m_valuesModel.clear();

    for (auto value : m_synonymousMap.values(ui->wordsTableView->model()->data(index).toString()))
    {
        m_valuesModel.appendRow(new QStandardItem(value));
    }
}
